<?php

namespace Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class Fac00200CancelamentoDeApuracao extends \Teknisa\GER\Controllers\TeknisaCrud {

	protected $dataSourceName;
    protected $parameterBagColumns = array();
    protected $CancelaApuracaoProcedure;

    public function __construct($crudService, $parameterBag,  $environment, $entityManager) {
        $this->crudService  = $crudService;
        $this->parameterBag = $parameterBag;
        $this->environment  = $environment;
        $this->entityManager = $entityManager;
    }

    public function cancelarApuracao(DTO\Request\DataSet $request, DTO\Response $response) {
        $rows = $request->getDataSet()->getRows();
        $row = $rows[0];
        $row['CDOPERADOR'] = $this->environment->getCdOperador();
        $row['NRORG'] = $this->environment->getNrOrg();
        $this->cancelaApuracFacmProcedure($row,$response);
    }

    private function cancelaApuracFacmProcedure($row, $response){
        try {
            $procedure = new StoredProcedure($this->entityManager->getConnection(), 'CANCELA_APURAC_FACM');
            $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $row['CDFILIAL'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDCIA', Param::PARAM_INPUT, $row['CDCIA'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRAPURACFATM', Param::PARAM_INPUT, $row['NRAPURACFATM'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DATAINI', Param::PARAM_INPUT, $row['DTINICIAL'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DATAFIN', Param::PARAM_INPUT, $row['DTFINAL'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDOPERADOR', Param::PARAM_INPUT, $row['CDOPERADOR'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRORG', Param::PARAM_INPUT, $row['NRORG'], Param::PARAM_TYPE_STR));
            $procedure->execute();
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
}