DROP VIEW ETL_CONTAPAGA
/

CREATE VIEW ETL_CONTAPAGA AS
SELECT * 
  FROM (SELECT FO.NMFANTFORN, -- DIMENSO 00318 FORNECEDOR (NOME FANTASIA)
               FO.NMFANTFORN NMPARCNEGOCIO, -- DIMENSO 00286 PARCEIRO (CLI-FOR)
               FO.NMRAZSOCFORN,
               FO.DTCADAFORN,
               TO_CHAR(FO.DTCADAFORN, 'YYYY/MM/DD') DSANOMESDIACADA,
               TO_CHAR(FO.DTCADAFORN, 'YYYY/MM') DSANOMESCADA,
               TO_CHAR(FO.DTCADAFORN, 'YYYY') ANCADACLIE,
               GR.CDGRUPFORN,
               NVL(GR.NMGRUPFORN, 'NO CADASTRADO') NMGRUPFORN, -- DIMENSO 00458 GRUPO DE FORNECEDOR
               CT.CDTPCTPAGAR, -- DIMENSO 00270 TIPO DE CONTA PAGA
               'PAG-'||TP.DSTPCTPAGAR TIPO_CONTA, -- DIMENSO 00279 TIPO DE CONTA (PAG-REC)
               LTRIM(SUBSTR(TO_CHAR(SUM(1) OVER (PARTITION BY FO.NMFANTFORN, CT.CDTPCTPAGAR
                                           ORDER BY FO.NMFANTFORN, CT.CDTPCTPAGAR, BA.DTBAIXAPAG
                                           ROWS BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW), '99999'), 2, 5)) NRPAGAMENTO_TIPO_CONTA, -- DIMENSO 00457 N DO PAGAMENTO
               BA.CDREDUCONT, -- DIMENSO 06000 CONTA CORRENTE
               TO_CHAR(BA.DTBAIXAPAG, 'YYYY') DSANO, -- DIMENSO 00025 ANO
               TO_CHAR(BA.DTBAIXAPAG, 'YYYY-MM') DSMES, -- DIMENSO 00027 MS
               TO_CHAR(TRUNC((TO_CHAR(BA.DTBAIXAPAG, 'MM') - 1) / 2) + 1)||' BIM' DSBIMESTRE, -- DIMENSO 00011 BIMESTRE
               TO_CHAR(TRUNC((TO_CHAR(BA.DTBAIXAPAG, 'MM') - 1) / 3) + 1)||' TRI' DSTRIMESTRE, -- DIMENSO 00012 TRIMESTRE
               TO_CHAR(TRUNC((TO_CHAR(BA.DTBAIXAPAG, 'MM') - 1) / 6) + 1)||' SEM' DSSEMESTRE, -- DIMENSO 00013 SEMESTRE
               BA.DTBAIXAPAG,
               TO_CHAR(BA.DTBAIXAPAG, 'YYYY/MM/DD') DSANOMESDIAPAG, -- DIMENSO 00459 PAG.(BAIXA) - DIA
               TO_CHAR(BA.DTBAIXAPAG, 'YYYY/MM') DSANOMESPAG, -- DIMENSO 00460 PAG.(BAIXA) - MS
               CASE WHEN (TO_CHAR(BA.DTBAIXAPAG, 'DD') >= '21') AND (TO_CHAR(BA.DTBAIXAPAG, 'DD') <= '31')
                    THEN TO_CHAR(TO_DATE('21/'||TO_CHAR(BA.DTBAIXAPAG, 'MM/YYYY')), 'YYYY-MM-DD')||' A '||
                         TO_CHAR(ADD_MONTHS(TO_DATE('20/'||TO_CHAR(BA.DTBAIXAPAG, 'MM/YYYY')), 1), 'YYYY-MM-DD')
                    ELSE TO_CHAR(ADD_MONTHS(TO_DATE('21/'||TO_CHAR(BA.DTBAIXAPAG, 'MM/YYYY')), -1), 'YYYY-MM-DD')||' A '||
                         TO_CHAR(TO_DATE('20/'||TO_CHAR(BA.DTBAIXAPAG, 'MM/YYYY')), 'YYYY-MM-DD')
                     END AS DSPERIODOPAG, -- DIMENSO 00316 PERODO
               TO_CHAR(BA.DTBAIXAPAG, 'YYYY') ANBAIXAPAG, -- DIMENSO 00461 PAG.(BAIXA) - ANO
               BA.NRBAIXAPAG,
               BO.CDEMPRESA, -- DIMENSO 00264 EMPRESA
               BA.CDFILIAL,
               BO.NRLANBOLPAG,
               BO.DTVENBOLPAG,
               DSCONTCORR,
               CASE WHEN SUBSTR(CC.DSCONTCORR, 1, 2) = 'AP' THEN 'Aplicao Financeira'
                    WHEN SUBSTR(CC.DSCONTCORR, 1, 2) = 'CC' THEN 'Conta Corrente'
                    ELSE 'Indefinida'
                     END AS DSFINALIDADE_CONTCORR, -- DIMENSO 06001 FINALIDADE DA CONTA
               ROUND(BO.VRBOLPAG, 2) BOLETO_VALOR_BRUTO,
               ROUND(BO.VRFINALBPAG, 2) BOLETO_VALOR_LIQUIDO,
               ROUND(BO.VRFINALBPAG, 2) - ROUND(BO.VRBOLPAG, 2) BOLETO_AJUSTE,
               ROUND(CT.VRATUAPAG, 2) CONTA_VALOR_INICIAL,
               (BO.VRFINALBPAG - BO.VRBOLPAG) * (CT.VRATUAPAG/BO.VRBOLPAG) CONTA_AJUSTE,
               ROUND(CT.VRATUAPAG, 2) + ((BO.VRFINALBPAG - BO.VRBOLPAG) * (CT.VRATUAPAG/BO.VRBOLPAG)) CONTA_AJUSTADA_PAGA
          FROM CONTAPAGAR CT, BOLETPAGAR BO, BAIXAPAGA BA, FORNECEDOR FO, GRUPFORN GR, TIPOCTPAGAR TP, CONTCORR CC
         WHERE BO.CDFILIAL = CT.CDFILIBPAG
           AND BO.NRLANBOLPAG = CT.NRLANBOLPAG
           AND BO.VRFINALBPAG <> 0
           AND BA.CDFILIAL = BO.CDFILIBAIPAG
           AND BA.NRBAIXAPAG = BO.NRBAIXAPAG
           AND FO.CDFORNECED = BO.CDFORNECED
           AND GR.CDGRUPFORN (+) = FO.CDGRUPFORN
           AND TP.CDTPCTPAGAR = CT.CDTPCTPAGAR
           AND CC.CDREDUCONT = BA.CDREDUCONT)
/

-- VERSAO --
BEGIN ATUVEROBJ('ETL_CONTARECEBIDA','0.00.000'); END;
/
